#include "stdafx.h"


TCHAR *bintohex(TCHAR *fullPath) {
	CFile rfile, wfile;
	unsigned char bin[16];
	char hex[64];
	int ok;
	TCHAR path[_MAX_PATH];
	TCHAR drive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1];
	TCHAR fname[_MAX_FNAME + 1];
	TCHAR ext[_MAX_EXT + 1];

	_tsplitpath_s(fullPath, drive, _MAX_DRIVE, dir, _MAX_DIR, fname, _MAX_FNAME, ext, _MAX_EXT);
	if ((_tcscmp(ext, _T(".bin")) != 0) && (_tcscmp(ext, _T(".BIN")) != 0)) {
		return _T("gqbinł͂܂.");
	}
	_tmakepath_s(path, _MAX_PATH, drive, dir, fname, _T("hex"));

	ok = rfile.Open(fullPath, CFile::modeRead);
	if (!ok) {
		return _T("oCit@CJ܂.");
	}
	ok = wfile.Open(path, CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate);
	if (!ok) {
		rfile.Close();
		return _T("HEXt@C쐬ł܂.");
	}

	unsigned int address = 0;
	int count;
	int i;
	int blank;
	unsigned char checksum;
	do {
		count = rfile.Read(bin, 16);
		sprintf_s(&hex[0], 7 + 1, ":%02X%04X", count, address);
		sprintf_s(&hex[7], 2 + 1, "00");
		blank = 1;
		for (i = 0; i < count; i++) {
			sprintf_s(&hex[i * 2 + 9], 2 + 1, "%02X", bin[i]);
			if (bin[i] != 0xff)
				blank = 0;
		}
		if (!blank) {
			checksum = (count & 0xff) + (address & 0xff) + ((address >> 8) & 0xff) + 00;
			for (i = 0; i < count; i++)
				checksum += bin[i];
			checksum = ~checksum + 1;
			sprintf_s(&hex[count * 2 + 9], 2 + 1, "%02X", checksum);
			hex[count * 2 + 11] = 13;
			hex[count * 2 + 12] = 10;

			//
			TRY{
				wfile.Write(hex, count * 2 + 13);
			}
				CATCH(CFileException, e) {
				rfile.Close();
				wfile.Close();
				return _T("݂Ɏs܂.");
			}
			END_CATCH
		}
		address += count;
	} while (count == 16);
	sprintf_s(hex, 11 + 1, ":00000001FF");
	TRY{
		wfile.Write(hex, 11);
	}
		CATCH(CFileException, e) {
		rfile.Close();
		wfile.Close();
		return _T("݂Ɏs܂.");
	}
	END_CATCH

		rfile.Close();
	wfile.Close();
	return NULL;
}
