/*
  TOYOSHIKI Tiny BASIC for Arduino
  (C)2012 Tetsuya Suzuki
*/

#define _LED_
#define _SW_
#define _PIO_

void basic(void);

#ifdef _PIO_
  #ifndef _LED_
  #define _LED_
  #endif
  #ifndef _SW_
  #define _SW_
  #endif
#endif
#ifdef _LED_
extern const signed char leds[] = {13, -1}; //LED番号の登録
#endif
#ifdef _SW_
extern const signed char sws[] = {4, 3, 2, -1}; //ピン番号の登録
#endif

void setup(void) {
  // put your setup code here, to run once:
  Serial.begin(9600);
  randomSeed(analogRead(0));
#ifdef _LED_
  unsigned char led; //ループカウンタ
  for(led = 0; leds[led] != -1; led++) //LEDの数だけ繰り返す
    pinMode(leds[led], OUTPUT); //ピンを出力に設定
#endif
#ifdef _SW_
  unsigned char sw; //ループカウンタ
  for(sw = 0; sws[sw] != -1; sw++) //ピンの数だけ繰り返す
    pinMode(sws[sw], INPUT_PULLUP); //ピンをプルアップ付き入力に設定
#endif
}

void loop(void) {
  // put your main code here, to run repeatedly:
  basic();
}
